import os
import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()
from tensorflow.keras.datasets.mnist import load_data

print('MNISTの取得：', flush=True)
mnist = load_data()
test_x = [p.reshape(784)/255 for p in mnist[1][0]]
test_z = [[0]*d+[1]+[0]*(10-d-1) for d in mnist[1][1]]
print('完了')

x = tf.placeholder(tf.float32, [None, 784])
w = tf.Variable(tf.zeros([784, 10]))
b = tf.Variable(tf.zeros([10]))
y = tf.matmul(x, w) + b
z = tf.placeholder(tf.float32, [None, 10])

saver = tf.train.Saver()
session = tf.Session()

path = os.path.abspath(os.path.dirname(__file__))
saver.restore(session, os.path.join(path, 'tf_model'))

yl = tf.argmax(y, 1)
zl = tf.argmax(z, 1)
ac = tf.reduce_mean(tf.cast(tf.equal(yl, zl), tf.float32))
y_label, z_label, accuracy = session.run(
    (yl, zl, ac), feed_dict={x:test_x, z:test_z})

print('テスト結果：')
count = [[0 for i in range(10)] for j in range(10)]
for i, j in zip(y_label, z_label):
    count[i][j] += 1
print('正解   ', end='')
for i in range(10):
    print('   [{0}]'.format(i), end='')
print()
for i in range(10):
    print('予測[{0}]'.format(i), end='')
    for j in range(10):
        print('{0:6d}'.format(count[i][j]), end='')
    print()

print('正解率：', accuracy*100, '%')
