import dl_model
import os
import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()
from tensorflow.keras.datasets.mnist import load_data

print('MNISTの取得：', flush=True)
mnist = load_data()
test_x = [p.reshape(784)/255 for p in mnist[1][0]]
test_z = [[0]*d+[1]+[0]*(10-d-1) for d in mnist[1][1]]
print('完了')

x = tf.placeholder(tf.float32, [None, 784])
z = tf.placeholder(tf.float32, [None, 10])
y, keep_prob = dl_model.deepnn(x)

yl = tf.argmax(y, 1)
zl = tf.argmax(z, 1)
ac = tf.reduce_mean(tf.cast(tf.equal(yl, zl), tf.float32))

saver = tf.train.Saver()
session = tf.Session()
path = os.path.abspath(os.path.dirname(__file__))
saver.restore(session, os.path.join(path, 'dl_model'))

BATCH = 100
print('テスト結果：', flush=True)
count = [[0 for i in range(10)] for j in range(10)]
score = 0
for i in range(0, len(test_x), BATCH):
    bx, bz = test_x[i:i+BATCH], test_z[i:i+BATCH]
    y_label, z_label = session.run(
        (yl, zl), feed_dict={x:bx, z:bz, keep_prob:1.0})
    for j, k in zip(y_label, z_label):
        count[j][k] += 1
        score += 1 if j == k else 0
    if i//BATCH%10 == 0:
        progress = (i+BATCH)/len(test_x)*100
        accuracy = score/(i+BATCH)*100
        print('進捗率{0:6.2f}%：正解率{1:6.2f}%'.format(
            progress, accuracy))

print('正解   ', end='')
for i in range(10):
    print('   [{0}]'.format(i), end='')
print()
for i in range(10):
    print('予測[{0}]'.format(i), end='')
    for j in range(10):
        print('{0:6d}'.format(count[i][j]), end='')
    print()
print('正解率：', score/len(test_x)*100, '%')
